interface DropdownItem {
    value: string;
    text: string;
    html?: HTMLElement
}

interface DropdownOptions {
    textkey?: string;
    valuekey?: string;
    htmlkey?: string;
    maxlength?: Number;
    multiselect?: boolean;
    selected?: DropdownItem | any;
    selectedlist?: Array<DropdownItem | any>;
    disabled?: boolean;
    input?: boolean;
    search?: boolean;
    searchkeys?: Array<string>;
    searchplaceholder?: string;
    tabindex?: Number;
    slidefixed?: boolean;
    parent?: HTMLElement
}

interface Dropdown {
    sourceFilter: () => Array<DropdownItem | any>;
    onselectedlist: (list: Array<DropdownItem | any>) => void;
    onselected: (item: DropdownItem | any) => void;
    onexpanded: () => void;

    create(): HTMLElement;
    readonly multiselect: boolean;
    get disabled(): boolean;
    set disabled(flag: boolean);
    get source(): Array<DropdownItem | any>;
    set source(list: Array<DropdownItem | any>): void;
    readonly selected: DropdownItem | any;
    readonly selectedlist: Array<DropdownItem | any>;
    select(selected: DropdownItem | any, init?: boolean): void;
    selectlist(selectedlist: Array<DropdownItem | any>, init?: boolean): void;
}

declare var Dropdown: {
    prototype: Dropdown;
    new(options?: DropdownOptions): Dropdown;

    resolve(dom?: HTMLElement): HTMLElement;
}

export default Dropdown;